1
0

install.sh 7.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch3xui() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  30. esac
  31. }
  32. echo "arch: $(arch3xui)"
  33. os_version=""
  34. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  35. if [[ "${release}" == "centos" ]]; then
  36. if [[ ${os_version} -lt 8 ]]; then
  37. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  38. fi
  39. elif [[ "${release}" == "ubuntu" ]]; then
  40. if [[ ${os_version} -lt 20 ]]; then
  41. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  42. fi
  43. elif [[ "${release}" == "fedora" ]]; then
  44. if [[ ${os_version} -lt 36 ]]; then
  45. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  46. fi
  47. elif [[ "${release}" == "debian" ]]; then
  48. if [[ ${os_version} -lt 11 ]]; then
  49. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  50. fi
  51. elif [[ "${release}" == "almalinux" ]]; then
  52. if [[ ${os_version} -lt 9 ]]; then
  53. echo -e "${red} Please use AlmaLinux 9 or higher ${plain}\n" && exit 1
  54. fi
  55. elif [[ "${release}" == "rocky" ]]; then
  56. if [[ ${os_version} -lt 9 ]]; then
  57. echo -e "${red} Please use RockyLinux 9 or higher ${plain}\n" && exit 1
  58. fi
  59. elif [[ "${release}" == "arch" ]]; then
  60. echo "Your OS is ArchLinux"
  61. elif [[ "${release}" == "manjaro" ]]; then
  62. echo "Your OS is Manjaro"
  63. elif [[ "${release}" == "armbian" ]]; then
  64. echo "Your OS is Armbian"
  65. else
  66. echo -e "${red}Failed to check the OS version, please contact the author!${plain}" && exit 1
  67. fi
  68. install_base() {
  69. case "${release}" in
  70. centos | almalinux | rocky)
  71. yum -y update && yum install -y -q wget curl tar
  72. ;;
  73. fedora)
  74. dnf -y update && dnf install -y -q wget curl tar
  75. ;;
  76. arch | manjaro)
  77. pacman -Syu && pacman -Syu --noconfirm wget curl tar
  78. ;;
  79. *)
  80. apt-get update && apt install -y -q wget curl tar
  81. ;;
  82. esac
  83. }
  84. # This function will be called when user installed x-ui out of security
  85. config_after_install() {
  86. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  87. read -p "Do you want to continue with the modification [y/n]?": config_confirm
  88. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  89. read -p "Please set up your username:" config_account
  90. echo -e "${yellow}Your username will be:${config_account}${plain}"
  91. read -p "Please set up your password:" config_password
  92. echo -e "${yellow}Your password will be:${config_password}${plain}"
  93. read -p "Please set up the panel port:" config_port
  94. echo -e "${yellow}Your panel port is:${config_port}${plain}"
  95. echo -e "${yellow}Initializing, please wait...${plain}"
  96. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  97. echo -e "${yellow}Account name and password set successfully!${plain}"
  98. /usr/local/x-ui/x-ui setting -port ${config_port}
  99. echo -e "${yellow}Panel port set successfully!${plain}"
  100. else
  101. echo -e "${red}cancel...${plain}"
  102. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  103. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  104. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  105. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp}
  106. echo -e "this is a fresh installation,will generate random login info for security concerns:"
  107. echo -e "###############################################"
  108. echo -e "${green}username:${usernameTemp}${plain}"
  109. echo -e "${green}password:${passwordTemp}${plain}"
  110. echo -e "###############################################"
  111. echo -e "${red}if you forgot your login info,you can type x-ui and then type 7 to check after installation${plain}"
  112. else
  113. echo -e "${red} this is your upgrade,will keep old settings,if you forgot your login info,you can type x-ui and then type 7 to check${plain}"
  114. fi
  115. fi
  116. /usr/local/x-ui/x-ui migrate
  117. }
  118. install_x-ui() {
  119. cd /usr/local/
  120. if [ $# == 0 ]; then
  121. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  122. if [[ ! -n "$last_version" ]]; then
  123. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  124. exit 1
  125. fi
  126. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  127. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz
  128. if [[ $? -ne 0 ]]; then
  129. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  130. exit 1
  131. fi
  132. else
  133. last_version=$1
  134. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch3xui).tar.gz"
  135. echo -e "Beginning to install x-ui $1"
  136. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch3xui).tar.gz ${url}
  137. if [[ $? -ne 0 ]]; then
  138. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  139. exit 1
  140. fi
  141. fi
  142. if [[ -e /usr/local/x-ui/ ]]; then
  143. systemctl stop x-ui
  144. rm /usr/local/x-ui/ -rf
  145. fi
  146. tar zxvf x-ui-linux-$(arch3xui).tar.gz
  147. rm x-ui-linux-$(arch3xui).tar.gz -f
  148. cd x-ui
  149. chmod +x x-ui
  150. # Check the system's architecture and rename the file accordingly
  151. if [[ $(arch3xui) == "armv5" || $(arch3xui) == "armv6" || $(arch3xui) == "armv7" ]]; then
  152. mv bin/xray-linux-$(arch3xui) bin/xray-linux-arm
  153. chmod +x bin/xray-linux-arm
  154. fi
  155. chmod +x x-ui bin/xray-linux-$(arch3xui)
  156. cp -f x-ui.service /etc/systemd/system/
  157. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  158. chmod +x /usr/local/x-ui/x-ui.sh
  159. chmod +x /usr/bin/x-ui
  160. config_after_install
  161. systemctl daemon-reload
  162. systemctl enable x-ui
  163. systemctl start x-ui
  164. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  165. echo -e ""
  166. echo -e "x-ui control menu usages: "
  167. echo -e "----------------------------------------------"
  168. echo -e "x-ui - Enter Admin menu"
  169. echo -e "x-ui start - Start x-ui"
  170. echo -e "x-ui stop - Stop x-ui"
  171. echo -e "x-ui restart - Restart x-ui"
  172. echo -e "x-ui status - Show x-ui status"
  173. echo -e "x-ui enable - Enable x-ui on system startup"
  174. echo -e "x-ui disable - Disable x-ui on system startup"
  175. echo -e "x-ui log - Check x-ui logs"
  176. echo -e "x-ui banlog - Check Fail2ban ban logs"
  177. echo -e "x-ui update - Update x-ui"
  178. echo -e "x-ui install - Install x-ui"
  179. echo -e "x-ui uninstall - Uninstall x-ui"
  180. echo -e "----------------------------------------------"
  181. }
  182. echo -e "${green}Running...${plain}"
  183. install_base
  184. install_x-ui $1